<id>
Advanced Tabs for YaBB 2.2
</id>

<version>
1.04
</version>

<mod info>
With this mod the admin will have the option to add, edit and delete new tabs in the tab-menu.
The admin will also be able to change the order of appearence of the tabs in the menu.

This mod will also fix the problem with tabs wrapping and add the Tabbed menu to the wysiwyg css editor 
as part of the "#container" style.

Included in the zip package is a new default.css file to add more wysiwyg options and help fix
the tab-wrapping problem. If you dont want to overwrite your default.css file you can copy the styles
from the 'css_adds_tabs.txt' file included in the zip package and paste them into your 'default.css' file
REPLACING THE SIMILAR STYLES THERE.

Apply this mod.

Upload (in ASCII mode):

cgi-bin/yabb2/Admin/ManageTemplates.pl
cgi-bin/yabb2/Admin/ModList.pl
cgi-bin/yabb2/Languages/English/Templates.lng
cgi-bin/yabb2/Sources/SubList.pl
cgi-bin/yabb2/Sources/TabMenu.pl
cgi-bin/yabb2/Templates/default/default.html
cgi-bin/yabb2/Templates/default/MyCenter.template

Upload from the zip package (in ASCII mode):

cgi-bin/yabb2/Languages/English/tabmenu.lng
cgi-bin/yabb2/Sources/AdvancedTabs.pl
yabbfiles/Templates/Forum/default.css

Upload from the zip package (in Binary mode):

yabbfiles/Templates/Forum/default/*.png
yabbfiles/Templates/Forum/default/*.gif

</mod info>

<author>
Carsten
</author>

<edit file>
Admin/ManageTemplates.pl
</edit file>

<search for>
	$tempimages = qq~$forumstylesurl/$aktimages~;
</search for>

<add after>

	my $istabbed = 0;

</add after>

<search for>
		$style_sgl =~ s/\t//g;
</search for>

<add after>
		$style_sgl =~ s/\.\/default/$forumstylesurl\/default/g;
		$style_sgl =~ s/\.\/$viewcss/$forumstylesurl\/$viewcss/g;
</add after>

<search for>
	if ($stylestr =~ /\.seperator/) {
</search for>

<add before>
	if ($stylestr =~ /\.tabmenu/) {
		$istabbed = 1;
	}
	if ($stylestr =~ /\.tabtitle/ && $istabbed) {
		$tabtitlestyle = $stylestr;
		$tabtitlestyle =~ s/.*?(\.tabtitle\s*?\{.+?\}).*/$1/ig;
		$tabtitlestyle = $tabtitlestyle;
		$selstyl .= qq~<option value='$tabtitlestyle'>$templ_txt{'tabtitle'}</option>\n~;
		if ($stylestr =~ /\.tabtitle a/) {
			$tabtitlestyle_a = $stylestr;
			$tabtitlestyle_a =~ s/.*?(\.tabtitle a\s*?\{.+?\}).*/$1/ig;
			$selstyl .= qq~<option value='$tabtitlestyle_a'>$templ_txt{'tabtitlea'}</option>\n~;
		}
	}
</add before>

<search for>
	$viewstyle = qq~
<body>
</search for>

<add after>
<div id="maincontainer">
</add after>

<search for>
	if ($containerstyle) {
		$viewstyle .= qq~
<div id="container">
</search for>

<add after>
~;
}
if($istabbed) {
$tabsep = qq~<img src="$imagesdir/tabsep211.png" border="0" alt="" style="float: left; vertical-align: middle;" />~;
$tabfill = qq~<img src="$imagesdir/tabfill.gif" border="0" alt="" style="vertical-align: middle;" />~;
$tabtime = &timeformat($date, 1);

$viewstyle .= qq~
<table width="100%" cellpadding="0" cellspacing="0" border="0" class="menutop">
	<tr>
		<td class="small" align="left" valign="middle" width="2%" height="23">&nbsp;</td>
		<td class="small" align="left" valign="middle" width="98%" height="23"><span class="ie6alpha">$tabtime</span></td>
	</tr>
</table>
<table class="windowbg2" width="100%" cellpadding="4" cellspacing="0" border="0">
	<tr>
		<td align="left" valign="top" width="100%" height="30">&nbsp;</td>
	</tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0" border="0">
	<tr>
		<td class="menutop" height="22" align="left">&nbsp;</td>
	</tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0" border="0">

<tr>
	<td id="tabmnleft" class="tabmenuleft" width="40">&nbsp;</td>
	<td id="tabmn" class="tabmenu">
	<span class="selected"><a href="javascript:;">$tabfill$img_txt{'103'}$tabfill</a></span>
	$tabsep<span style="cursor:help;"><a href="javascript:;" style="cursor:help;">$tabfill$img_txt{'119'}$tabfill</a></span>
	$tabsep<span><a href="javascript:;">$tabfill$img_txt{'182'}$tabfill</a></span>
	$tabsep<span><a href="javascript:;">$tabfill$img_txt{'331'}$tabfill</a></span>
	$tabsep<span><a href="javascript:;">$tabfill$img_txt{'mycenter'}$tabfill</a></span>
	$tabsep<span><a href="javascript:;">$tabfill$img_txt{'108'}$tabfill</a></span>
	$tabsep
	</td>
	<td id="tabmnrss" class="tabmenu" width="40" valign="top"></td>
	<td id="tabmnright" class="tabmenuright" width="45">&nbsp;	</td>
	<td id="tabmnbox" class="rightbox" width="160" valign="top">
		<div style="float: left; width: 160px; height: 21px; text-align: center; padding-top: 3px; display: inline;">
		<input type="text" name="search" size="16" style="font-size: 11px; vertical-align: middle;" />
		<img src="$imagesdir/search.gif" style="border: 0; background-color: transparent; margin-right: 5px; vertical-align: middle;" />
		</div>
	</td>
</tr>
<tr>
	<td colspan="5"><br />&nbsp;</td>
</tr>
</table>
~;
}
	if ($containerstyle) {
		$viewstyle .= qq~
</add after>

<search for>
	$viewstyle .= qq~
<table class="bordercolor" cellpadding="4" cellspacing="1" border="0" width="100%">
<tr>
<td id="title" class="titlebg" width="50%" align="left" valign="middle">
$templ_txt{'30'}
</search for>

<add before>
if($istabbed) {
	$viewstyle .= qq~
<table cellpadding="0" cellspacing="0" border="0" width="100%" class="bordercolor">
<tr>
	<td class="tabtitle" width="1%" height="25" align="left" valign="middle">
		&nbsp;
	</td>
	<td class="tabtitle" width="49%" height="25" align="left" valign="middle">
		<span class="ie6alpha">$templ_txt{'tabtitle'}</span>
	</td>
	<td class="tabtitle" width="50%" height="25" align="left" valign="middle">
		<span class="ie6alpha"><a href="javascript:;">$templ_txt{'tabtitlea'}</a></span>
	</td>
</tr>
</table>
<br />
~;
}
</add before>

<search for>
	if ($bodycontainerstyle) {
		$viewstyle .= qq~</div>~;
	}
</search for>

<add after>
	if($istabbed) {
$viewstyle .= qq~
		<br />
		<div class="mainbottom">
		<table width="100%" cellpadding="0" cellspacing="0" border="0">
			<tr>
				<td class="nav" height="22" width="100%" align="left">&nbsp;</td>
			</tr>
		</table>
		</div>
~;
	}
</add after>

<search for>
</body>
</html>~;
</search for>

<add before>
<br /><br />
</div>
</add before>


<search for>
		document.allstyles.textcol.value = thecolor;
</search for>

<add after>
		if(cssoption.match(/\\#container\\s*?\\{/)) {
			thenewstyle=thenewstyle.replace(/(\\.tabmenu span a\\s*?\\{.*?color\\s*?\\:).+?(\\;)/ig, "\$1 " + thecolor + "\$2");
		}
</add after>

<search for>
		document.allstyles.backcol.value = thecolor;
</search for>

<add after>
		if(cssoption.match(/\\#container\\s*?\\{/)) {
			thenewstyle=thenewstyle.replace(/(\\.tabmenu.*?\\{.*?background-color\\s*?\\:).+?(\\;)/ig, "\$1 " + thecolor + "\$2");
			thenewstyle=thenewstyle.replace(/(\\.menutop.*?\\{.*?background-color\\s*?\\:).+?(\\;)/ig, "\$1 " + thecolor + "\$2");
			thenewstyle=thenewstyle.replace(/(\\.mainbottom.*?\\{.*?background-color\\s*?\\:).+?(\\;)/ig, "\$1 " + thecolor + "\$2");
			thenewstyle=thenewstyle.replace(/(\\.rightbox.*?\\{.*?background-color\\s*?\\:).+?(\\;)/ig, "\$1 " + thecolor + "\$2");
		}
</add after>

<search for>
			if($style_sgl =~ m~\;+\Z~) { $style_sgl = qq~\t$style_sgl~; }
</search for>

<add after>
			$style_sgl =~ s/$forumstylesurl/\./g;
</add after>

<search for>
	$tempmenu = qq~$tabsep<span title="$img_txt{'103'}" class="selected">$tabfill$img_txt{'103'}$tabfill</span>~;
</search for>

<replace>
	$tempmenu = qq~<span title="$img_txt{'103'}" class="selected">$tabfill$img_txt{'103'}$tabfill</span>~;
</replace>

<search for>
	$fulltemplate =~ s/({|<)yabb admin_alert(}|>)//g;
</search for>

<add after>
	$fulltemplate =~ s/({|<)yabb tabadd(}|>)//g;
	$fulltemplate =~ s/({|<)yabb addtab(}|>)//g;
</add after>


<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$advancedtabs_mod = qq~Advanced Tabs for YaBB 2.2|Carsten|With this mod the admin will have the option to add, edit and delete new tabs in the tab-menu. The admin will also be able to change the order of appearence of the tabs in the menu. This mod will also fix the problem with tabs wrapping and add the Tabbed menu to the wysiwyg css editor as part of the "#container" style.|1.04|12/23/07~;
	push (@installed_mods, "$advancedtabs_mod");

</add before>


<edit file>
Languages/English/Templates.lng
</edit file>

<search for>
);
</search for>

<add before>
'tabtitle' => 'Board Index Title (.tabtitle)',
'tabtitlea' => 'Board Index Title link (.tabtitle a)',
</add before>


<edit file>
Sources/SubList.pl
</edit file>

<search for>
%director=(
</search for>

<add after>
'addtab2',"AdvancedTabs.pl&AddNewTab2",
'edittab2',"AdvancedTabs.pl&EditTab2",
'deletetab',"AdvancedTabs.pl&DeleteTab",
'reordertab',"AdvancedTabs.pl&ReorderTab",
</add after>


<edit file>
Sources/TabMenu.pl
</edit file>

<search for>
sub mainMenu {
</search for>

<add before>
require "$sourcedir/AdvancedTabs.pl";

</add before>

<search for>
	my($homeclass, $helpclass, $searchclass, $memberlistclass, $favoritesclass, $loginclass, $sessionclass, $registerclass, $profileclass, $notificationclass, $logoutclass, $guestpmclass);
	
	if ($action ne "") {
		if ($action eq "help") { $helpclass = qq~ class="selected"~; }
		elsif ($action eq "search" || $action eq "search2") { $searchclass = qq~ class="selected"~; }
		elsif ($action eq "ml") { $memberlistclass = qq~ class="selected"~; }
		elsif ($action eq "login") { $loginclass = qq~ class="selected"~; }
		elsif ($action eq "revalidatesession") { $sessionclass = qq~ class="selected"~; }
		elsif ($action eq "register") { $registerclass = qq~ class="selected"~; }
		elsif ($action eq "mycenter" || $action eq "favorites" || $action eq "shownotify" || $action eq "im" || $action eq "imdraft" || $action eq "imoutbox" || $action eq "imstorage" || $action eq "imsend" || $action eq "imsend2" || $action eq "imshow" || $action eq "profileCheck" || $action eq "myviewprofile" || $action eq "myprofile" || $action eq "myprofileContacts" || $action eq "myprofileOptions" || $action eq "myprofileBuddy" || $action eq "myprofileIM" || $action eq "myprofileAdmin") { $userclass = qq~ class="selected"~; }
		elsif ($action eq "logout") { $logoutclass = qq~ class="selected"~; }
		elsif ($action eq "messagepagetext" || $action eq "messagepagedrop" || $action eq "threadpagetext" || $action eq "threadpagedrop") { $homeclass = qq~ class="selected"~; }
		elsif ($action eq "guestpm" || $action eq "guestpm2") { $guestpmclass = qq~ class="selected"~; }
	}
	else {
		$homeclass = qq~ class="selected"~;
	}
	
	$tabsep = qq~<img src="$imagesdir/tabsep211.png" border="0" alt="" style="float: left; vertical-align: middle;" />~;
	$tabfill = qq~<img src="$imagesdir/tabfill.gif" border="0" alt="" style="vertical-align: middle;" />~;
	
	$yytabmenu .= qq~$tabsep<span onclick="location.href='$scripturl';"$homeclass><a href="$scripturl" title = "$img_txt{'103'}">$tabfill$img_txt{'103'}$tabfill</a></span>~;
	$yytabmenu .= qq~$tabsep<span onclick="location.href='$scripturl?action=help';" style="cursor:help;"$helpclass><a href="$scripturl?action=help" title = "$img_txt{'119'}" style="cursor:help;">$tabfill$img_txt{'119'}$tabfill</a></span>~;
	if ($maxsearchdisplay > -1) {
		$yytabmenu .= qq~$tabsep<span onclick="location.href='$scripturl?action=search';"$searchclass><a href="$scripturl?action=search" title = "$img_txt{'182'}">$tabfill$img_txt{'182'}$tabfill</a></span>~;
	}
	if ((!$ML_Allowed && $iamguest) || ($ML_Allowed == 1 && !$iamguest) || ($ML_Allowed == 2 && $staff) || ($ML_Allowed == 3 && ($iamadmin || $iamgmod))) {
		$yytabmenu .= qq~$tabsep<span onclick="location.href='$scripturl?action=ml';"$memberlistclass><a href="$scripturl?action=ml" title = "$img_txt{'331'}">$tabfill$img_txt{'331'}$tabfill</a></span>~;
	}
	if ($iamadmin) {
		$yytabmenu .= qq~$tabsep<span><a href="$boardurl/AdminIndex.$yyaext" title = "$img_txt{'2'}">$tabfill$img_txt{'2'}$tabfill</a></span>~;
	}
	if ($iamgmod) {
		if (-e ("$vardir/gmodsettings.txt")) {
			require "$vardir/gmodsettings.txt";
		}
		if ($allow_gmod_admin) {
			$yytabmenu .= qq~$tabsep<span><a href="$boardurl/AdminIndex.$yyaext" title = "$img_txt{'2'}">$tabfill$img_txt{'2'}$tabfill</a></span>~;
		}
	}
	if ($sessionvalid == 0 && !$iamguest) {
		$sesredir = "";
		unless($action eq "revalidatesession" || $action eq "revalidatesession2") {
			$sestestenv = $testenv;
			$sestestenv =~ s/\=/\~/g;
			$sestestenv =~ s/;/x3B/g;
			if($sestestenv) { $sesredir = qq~;sesredir=$sestestenv~; }
		}
		$yytabmenu .= qq~$tabsep<span onclick="location.href='$scripturl?action=revalidatesession$sesredir';"$sessionclass><a href="$scripturl?action=revalidatesession$sesredir" title = "$img_txt{'34a'}">$tabfill$img_txt{'34a'}$tabfill</a></span>~;
	}
	if ($iamguest) {
		$yytabmenu .= qq~$tabsep<span onclick="location.href='$scripturl?action=login';"$loginclass><a href="$scripturl?action=login" title = "$img_txt{'34'}">$tabfill$img_txt{'34'}$tabfill</a></span>~;
		if (!$regdisable) {
			$yytabmenu .= qq~$tabsep<span onclick="location.href='$scripturl?action=register';"$registerclass><a href="$scripturl?action=register" title = "$img_txt{'97'}">$tabfill$img_txt{'97'}$tabfill</a></span>~;
		}
		if ($PMenableGuestButton && $PM_level  != 0) {
			$yytabmenu .= qq~$tabsep<span onclick="location.href='$scripturl?action=guestpm';"$guestpmclass><a href="$scripturl?action=guestpm" title = "$img_txt{'pmadmin'}">$tabfill$img_txt{'pmadmin'}$tabfill</a></span>~;
		}
	}
	else {
		$yytabmenu .= qq~$tabsep<span onclick="location.href='$scripturl?action=mycenter';"$userclass><a href="$scripturl?action=mycenter" title = "$img_txt{'mycenter'}">$tabfill$img_txt{'mycenter'}$tabfill</a></span>~;
		$yytabmenu .= qq~$tabsep<span onclick="location.href='$scripturl?action=logout';"$logoutclass><a href="$scripturl?action=logout" title = "$img_txt{'108'}">$tabfill$img_txt{'108'}$tabfill</a></span>~;
	}
	
	$yytabmenu .= qq~$tabsep~;
</search for>

<replace>
	if ($action eq "addtab" && $iamadmin) { &AddNewTab; }
	elsif ($action eq "edittab" && $iamadmin) { &EditTab; }
	elsif ($action ne "") {
		if ($action eq "search2") { $tmpaction = "search"; }
		elsif ($action eq "favorites" || $action eq "shownotify" || $action eq "im" || $action eq "imdraft" || $action eq "imoutbox" || $action eq "imstorage" || $action eq "imsend" || $action eq "imsend2" || $action eq "imshow" || $action eq "profileCheck" || $action eq "myviewprofile" || $action eq "myprofile" || $action eq "myprofileContacts" || $action eq "myprofileOptions" || $action eq "myprofileBuddy" || $action eq "myprofileIM" || $action eq "myprofileAdmin" || $action eq "myusersrecentposts") { $tmpaction = "mycenter"; }
		elsif ($action eq "messagepagetext" || $action eq "messagepagedrop" || $action eq "threadpagetext" || $action eq "threadpagedrop" || $action eq "post" || $action eq "notify" || $action eq "boardnotify" || $action eq "sendtopic" || $action eq "modify") { $tmpaction = "home"; }
		elsif ($action eq "guestpm2") { $tmpaction = "guestpm"; }
		else { $tmpaction = $action; }
	}
	else {
		$tmpaction = "home";
	}

	$tabsep = qq~<img src="$imagesdir/tabsep211.png" border="0" alt="" style="float: left; vertical-align: middle;" />~;
	$tabfill = qq~<img src="$imagesdir/tabfill.gif" border="0" alt="" style="vertical-align: middle;" />~;

	$tab{'home'} = qq~<span |><a href="$scripturl" title = "$img_txt{'103'}" style="padding: 3px 0 4px 0;">$tabfill$img_txt{'103'}$tabfill</a></span>~;
	$tab{'help'} = qq~<span |><a href="$scripturl?action=help" title = "$img_txt{'119'}" style="padding: 3px 0 4px 0; cursor:help;">$tabfill$img_txt{'119'}$tabfill</a></span>~;
	if ($maxsearchdisplay > -1) {
		$tab{'search'} = qq~<span |><a href="$scripturl?action=search" title = "$img_txt{'182'}" style="padding: 3px 0 4px 0;">$tabfill$img_txt{'182'}$tabfill</a></span>~;
	}
	if (!$ML_Allowed || ($ML_Allowed == 1 && !$iamguest) || ($ML_Allowed == 2 && $staff) || ($ML_Allowed == 3 && ($iamadmin || $iamgmod))) {
		$tab{'ml'} = qq~<span |><a href="$scripturl?action=ml" title = "$img_txt{'331'}" style="padding: 3px 0 4px 0;">$tabfill$img_txt{'331'}$tabfill</a></span>~;
	}
	if ($iamadmin) {
		$tab{'admin'} = qq~<span |><a href="$boardurl/AdminIndex.$yyaext" title = "$img_txt{'2'}" style="padding: 3px 0 4px 0;">$tabfill$img_txt{'2'}$tabfill</a></span>~;
	}
	if ($iamgmod) {
		if (-e ("$vardir/gmodsettings.txt")) {
			require "$vardir/gmodsettings.txt";
		}
		if ($allow_gmod_admin) {
			$tab{'admin'} = qq~<span |><a href="$boardurl/AdminIndex.$yyaext" title = "$img_txt{'2'}" style="padding: 3px 0 4px 0;">$tabfill$img_txt{'2'}$tabfill</a></span>~;
		}
	}
	if ($sessionvalid == 0 && !$iamguest) {
		$sesredir = "";
		unless($action eq "revalidatesession" || $action eq "revalidatesession2") {
			$sestestenv = $testenv;
			$sestestenv =~ s/\=/\~/g;
			$sestestenv =~ s/;/x3B/g;
			if($sestestenv) { $sesredir = qq~;sesredir=$sestestenv~; }
		}
		$tab{'revalidatesession'} = qq~<span |><a href="$scripturl?action=revalidatesession$sesredir" title = "$img_txt{'34a'}" style="padding: 3px 0 4px 0;">$tabfill$img_txt{'34a'}$tabfill</a></span>~;
	}
	if ($iamguest) {
		$tab{'login'} = qq~<span |><a href="$scripturl?action=login" title = "$img_txt{'34'}" style="padding: 3px 0 4px 0;">$tabfill$img_txt{'34'}$tabfill</a></span>~;
		if ($regtype) {
			$tab{'register'} = qq~<span |><a href="$scripturl?action=register" title = "$img_txt{'97'}" style="padding: 3px 0 4px 0;">$tabfill$img_txt{'97'}$tabfill</a></span>~;
		}
		if ($PMenableGuestButton && $PM_level  != 0) {
			$tab{'guestpm'} = qq~<span |><a href="$scripturl?action=guestpm" title = "$img_txt{'pmadmin'}" style="padding: 3px 0 4px 0;">$tabfill$img_txt{'pmadmin'}$tabfill</a></span>~;
		}
	}
	else {
		$tab{'mycenter'} = qq~<span |><a href="$scripturl?action=mycenter" title = "$img_txt{'mycenter'}" style="padding: 3px 0 4px 0;">$tabfill$img_txt{'mycenter'}$tabfill</a></span>~;
		$tab{'logout'} = qq~<span |><a href="$scripturl?action=logout" title = "$img_txt{'108'}" style="padding: 3px 0 4px 0;">$tabfill$img_txt{'108'}$tabfill</a></span>~;
	}

	&LoadTabmenu;
</replace>

<search for>
		$yymcmenu .= qq~$tabsep<span onclick="changeToTab('pm'); return false;"$pmclass id="menu_pm"><a href="$scripturl?action=mycenter" onclick="changeToTab('pm'); return false;">$tabfill$mc_menus{'messages'}$tabfill</a></span>
</search for>

<replace>
		$yymcmenu .= qq~<span onclick="changeToTab('pm'); return false;"$pmclass id="menu_pm"><a href="$scripturl?action=mycenter" onclick="changeToTab('pm'); return false;">$tabfill$mc_menus{'messages'}$tabfill</a></span>
</replace>


<edit file>
Templates/default/default.html
</edit file>

<search for>
		<td class="tabmenu" width="40" valign="top"><div style="float: left; width: 40px; height: 18px; text-align: center; padding-top: 6px; display: inline;">{yabb rss}</div></td>
		<td class="tabmenuright" width="40">&nbsp;	</td>
		<td class="rightbox" width="160" valign="top"><div style="float: left; width: 160px; height: 21px; text-align: center; padding-top: 3px; display: inline;">{yabb searchbox}</div></td>
	</tr>
</table>
</search for>

<replace>
		<td class="tabmenu" valign="top">{yabb tabadd}</td>
		<td class="tabmenu" width="40" valign="top"><div style="float: left; width: 40px; height: 18px; text-align: center; padding-top: 6px; display: inline;">{yabb rss}</div></td>
		<td class="tabmenuright" width="45">&nbsp;	</td>
		<td class="rightbox" width="160" valign="top"><div style="float: left; width: 160px; height: 21px; text-align: center; padding-top: 3px; display: inline;">{yabb searchbox}</div></td>
	</tr>
</table>
{yabb addtab}
</replace>


<edit file>
Templates/default/MyCenter.template
</edit file>

<search for>
		<td class="tabmenu" width="23%" align="center" >{yabb mcmenu}</td>
		<td class="tabmenuright" width="40">&nbsp;</td>
		<td class="rightbox" width="70%" valign="top">
</search for>

<replace>
		<td class="tabmenu" align="left">{yabb mcmenu}</td>
		<td class="tabmenuright" width="45">&nbsp;</td>
		<td class="rightbox" width="440" valign="top">
</replace>

